/* Time Set will set the time of a RTC within one second from the PC time.
naturlly the PC time must be correct... */

#include <DS3232RTC.h>
#define LAG 6 // how many seconds it takes to set the time.
tmElements_t tm;
int thisSecond = 0;
int lastSecond = 0;

void setup() {
  Serial.begin(115200);
  // http://www.rapidtables.com/calc/time/gmt-time.htm use this web page to adjust the LAG numer
  int timeOffset = 5; // set for current local time zone including DST
  char *compDate = __DATE__, *compTime = __TIME__, *months = "JanFebMarAprMayJunJulAugSepOctNovDec";
  char chMon[3], *m;
  int d, y;
  time_t t;
  strncpy(chMon, compDate, 3);
  chMon[3] = '\0';
  m = strstr(months, chMon);
  tm.Month = ((m - months) / 3 + 1);

  tm.Day = atoi(compDate + 4);
  tm.Year = atoi(compDate + 7) - 1970;
  tm.Hour = atoi(compTime) + timeOffset;
  tm.Minute = atoi(compTime + 3);
  tm.Second = atoi(compTime + 6);
  t = makeTime(tm);
  Serial.println(t + LAG);
  RTC.set(t + LAG);
}

void loop() {
  // put your main code here, to run repeatedly:
  RTC.read(tm);
  //Serial.println(RTC.get());
  thisSecond = tm.Second;
  if (thisSecond != lastSecond) { // prints out the time and date each second
    Serial.print(tm.Hour, DEC);
    Serial.print(":");
    if(tm.Minute < 10){
      Serial.print("0");
    }
    Serial.print(tm.Minute, DEC);
    Serial.print(":");
    if(tm.Second < 10){
      Serial.print("0");
    }
    Serial.print(tm.Second, DEC);
    Serial.print(" ");
    Serial.print(tm.Month);
    Serial.print("/");
    Serial.print(tm.Day);
    Serial.print("/");
    Serial.println(tm.Year);
  }
  lastSecond = thisSecond;
}
